# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`spamassassin`](#spamassassin): This module installs and configures spamassassin and a few of its
plugins.

#### Private Classes

* `spamassassin::config`: Configure spamassassin and related software.
* `spamassassin::install`: Install packages for spamassassin and related software.
* `spamassassin::params`: Default parameter values for class spamassassin
* `spamassassin::service`: Setup spamassassin service.

## Classes

### <a name="spamassassin"></a>`spamassassin`

For examples, see tests folder.

* **See also**
  * https://spamassassin.apache.org/full/4.0.x/doc/

#### Parameters

The following parameters are available in the `spamassassin` class:

* [`sa_update`](#-spamassassin--sa_update)
* [`run_execs_as_user`](#-spamassassin--run_execs_as_user)
* [`package_name`](#-spamassassin--package_name)
* [`service_enabled`](#-spamassassin--service_enabled)
* [`service_name`](#-spamassassin--service_name)
* [`notify_service_name`](#-spamassassin--notify_service_name)
* [`spamd_max_children`](#-spamassassin--spamd_max_children)
* [`spamd_min_children`](#-spamassassin--spamd_min_children)
* [`spamd_listen_address`](#-spamassassin--spamd_listen_address)
* [`spamd_allowed_ips`](#-spamassassin--spamd_allowed_ips)
* [`spamd_username`](#-spamassassin--spamd_username)
* [`spamd_groupname`](#-spamassassin--spamd_groupname)
* [`spamd_nouserconfig`](#-spamassassin--spamd_nouserconfig)
* [`spamd_allowtell`](#-spamassassin--spamd_allowtell)
* [`spamd_sql_config`](#-spamassassin--spamd_sql_config)
* [`spamd_syslog_facility`](#-spamassassin--spamd_syslog_facility)
* [`configdir`](#-spamassassin--configdir)
* [`spamd_options_file`](#-spamassassin--spamd_options_file)
* [`spamd_options_var`](#-spamassassin--spamd_options_var)
* [`spamd_defaults`](#-spamassassin--spamd_defaults)
* [`sa_update_file`](#-spamassassin--sa_update_file)
* [`required_score`](#-spamassassin--required_score)
* [`score_tests`](#-spamassassin--score_tests)
* [`whitelist_from`](#-spamassassin--whitelist_from)
* [`whitelist_from_rcvd`](#-spamassassin--whitelist_from_rcvd)
* [`whitelist_to`](#-spamassassin--whitelist_to)
* [`blacklist_from`](#-spamassassin--blacklist_from)
* [`blacklist_to`](#-spamassassin--blacklist_to)
* [`rewrite_header_subject`](#-spamassassin--rewrite_header_subject)
* [`rewrite_header_from`](#-spamassassin--rewrite_header_from)
* [`rewrite_header_to`](#-spamassassin--rewrite_header_to)
* [`report_safe`](#-spamassassin--report_safe)
* [`add_header_spam`](#-spamassassin--add_header_spam)
* [`add_header_ham`](#-spamassassin--add_header_ham)
* [`add_header_all`](#-spamassassin--add_header_all)
* [`remove_header_spam`](#-spamassassin--remove_header_spam)
* [`remove_header_ham`](#-spamassassin--remove_header_ham)
* [`remove_header_all`](#-spamassassin--remove_header_all)
* [`clear_trusted_networks`](#-spamassassin--clear_trusted_networks)
* [`trusted_networks`](#-spamassassin--trusted_networks)
* [`clear_internal_networks`](#-spamassassin--clear_internal_networks)
* [`internal_networks`](#-spamassassin--internal_networks)
* [`skip_rbl_checks`](#-spamassassin--skip_rbl_checks)
* [`dns_available`](#-spamassassin--dns_available)
* [`uridnsbl_skip_domain`](#-spamassassin--uridnsbl_skip_domain)
* [`uridnsbl`](#-spamassassin--uridnsbl)
* [`urirhsbl`](#-spamassassin--urirhsbl)
* [`urirhssub`](#-spamassassin--urirhssub)
* [`bayes_enabled`](#-spamassassin--bayes_enabled)
* [`bayes_use_hapaxes`](#-spamassassin--bayes_use_hapaxes)
* [`bayes_auto_learn`](#-spamassassin--bayes_auto_learn)
* [`bayes_ignore_header`](#-spamassassin--bayes_ignore_header)
* [`bayes_auto_expire`](#-spamassassin--bayes_auto_expire)
* [`bayes_sql_enabled`](#-spamassassin--bayes_sql_enabled)
* [`bayes_sql_dsn`](#-spamassassin--bayes_sql_dsn)
* [`bayes_sql_username`](#-spamassassin--bayes_sql_username)
* [`bayes_sql_password`](#-spamassassin--bayes_sql_password)
* [`bayes_sql_override_username`](#-spamassassin--bayes_sql_override_username)
* [`bayes_store_module`](#-spamassassin--bayes_store_module)
* [`bayes_path`](#-spamassassin--bayes_path)
* [`bayes_file_mode`](#-spamassassin--bayes_file_mode)
* [`bayes_auto_learn_threshold_nonspam`](#-spamassassin--bayes_auto_learn_threshold_nonspam)
* [`bayes_auto_learn_threshold_spam`](#-spamassassin--bayes_auto_learn_threshold_spam)
* [`user_scores_dsn`](#-spamassassin--user_scores_dsn)
* [`user_scores_sql_username`](#-spamassassin--user_scores_sql_username)
* [`user_scores_sql_password`](#-spamassassin--user_scores_sql_password)
* [`user_scores_sql_custom_query`](#-spamassassin--user_scores_sql_custom_query)
* [`dcc_enabled`](#-spamassassin--dcc_enabled)
* [`dcc_timeout`](#-spamassassin--dcc_timeout)
* [`dcc_body_max`](#-spamassassin--dcc_body_max)
* [`dcc_fuz1_max`](#-spamassassin--dcc_fuz1_max)
* [`dcc_fuz2_max`](#-spamassassin--dcc_fuz2_max)
* [`pyzor_enabled`](#-spamassassin--pyzor_enabled)
* [`pyzor_timeout`](#-spamassassin--pyzor_timeout)
* [`pyzor_max`](#-spamassassin--pyzor_max)
* [`pyzor_count_min`](#-spamassassin--pyzor_count_min)
* [`pyzor_options`](#-spamassassin--pyzor_options)
* [`pyzor_path`](#-spamassassin--pyzor_path)
* [`pyzor_home`](#-spamassassin--pyzor_home)
* [`razor_enabled`](#-spamassassin--razor_enabled)
* [`razor_timeout`](#-spamassassin--razor_timeout)
* [`razor_home`](#-spamassassin--razor_home)
* [`spamcop_enabled`](#-spamassassin--spamcop_enabled)
* [`spamcop_from_address`](#-spamassassin--spamcop_from_address)
* [`spamcop_to_address`](#-spamassassin--spamcop_to_address)
* [`spamcop_max_report_size`](#-spamassassin--spamcop_max_report_size)
* [`awl_enabled`](#-spamassassin--awl_enabled)
* [`awl_sql_enabled`](#-spamassassin--awl_sql_enabled)
* [`awl_dsn`](#-spamassassin--awl_dsn)
* [`awl_sql_username`](#-spamassassin--awl_sql_username)
* [`awl_sql_password`](#-spamassassin--awl_sql_password)
* [`awl_sql_override_username`](#-spamassassin--awl_sql_override_username)
* [`auto_whitelist_path`](#-spamassassin--auto_whitelist_path)
* [`auto_welcomelist_path`](#-spamassassin--auto_welcomelist_path)
* [`auto_whitelist_file_mode`](#-spamassassin--auto_whitelist_file_mode)
* [`auto_welcomelist_file_mode`](#-spamassassin--auto_welcomelist_file_mode)
* [`textcat_enabled`](#-spamassassin--textcat_enabled)
* [`ok_languages`](#-spamassassin--ok_languages)
* [`ok_locales`](#-spamassassin--ok_locales)
* [`normalize_charset`](#-spamassassin--normalize_charset)
* [`shortcircuit_enabled`](#-spamassassin--shortcircuit_enabled)
* [`shortcircuit_user_in_whitelist`](#-spamassassin--shortcircuit_user_in_whitelist)
* [`shortcircuit_user_in_def_whitelist`](#-spamassassin--shortcircuit_user_in_def_whitelist)
* [`shortcircuit_user_in_all_spam_to`](#-spamassassin--shortcircuit_user_in_all_spam_to)
* [`shortcircuit_subject_in_whitelist`](#-spamassassin--shortcircuit_subject_in_whitelist)
* [`shortcircuit_user_in_blacklist`](#-spamassassin--shortcircuit_user_in_blacklist)
* [`shortcircuit_user_in_blacklist_to`](#-spamassassin--shortcircuit_user_in_blacklist_to)
* [`shortcircuit_subject_in_blacklist`](#-spamassassin--shortcircuit_subject_in_blacklist)
* [`shortcircuit_all_trusted`](#-spamassassin--shortcircuit_all_trusted)
* [`dkim_enabled`](#-spamassassin--dkim_enabled)
* [`dkim_timeout`](#-spamassassin--dkim_timeout)
* [`rules2xsbody_enabled`](#-spamassassin--rules2xsbody_enabled)
* [`custom_rules`](#-spamassassin--custom_rules)
* [`custom_config`](#-spamassassin--custom_config)

##### <a name="-spamassassin--sa_update"></a>`sa_update`

Data type: `Boolean`

Enable the sa-update cron job.

Default value: `false`

##### <a name="-spamassassin--run_execs_as_user"></a>`run_execs_as_user`

Data type: `Optional[String]`

If you enabled razor and/or pyzor and would like the razor-admin or pyzor
discover commands to be run as a different user specify the username in this
directive. Example: `amavis`

Default value: `undef`

##### <a name="-spamassassin--package_name"></a>`package_name`

Data type: `String`

The package name to use. Default is distribution-specific

Default value: `$spamassassin::params::package_name`

##### <a name="-spamassassin--service_enabled"></a>`service_enabled`

Data type: `Boolean`

Will enable service at boot and ensure a running service.

Default value: `false`

##### <a name="-spamassassin--service_name"></a>`service_name`

Data type: `String`

The service name to use for the spamassassin service. Default is
distribution-specific

Default value: `$spamassassin::params::service_name`

##### <a name="-spamassassin--notify_service_name"></a>`notify_service_name`

Data type: `Optional[String]`

If specified then this service will be notified instead of "spamd" when
config is update. Only has an effect if service_enabled is false.

Default value: `undef`

##### <a name="-spamassassin--spamd_max_children"></a>`spamd_max_children`

Data type: `Integer[1]`

The maximum number of children to spawn. Spamd will spawn that number of
children, then sleep in the background until a child dies, wherein it will
go and spawn a new child.

Default value: `5`

##### <a name="-spamassassin--spamd_min_children"></a>`spamd_min_children`

Data type: `Optional[Integer[1]]`

The minimum number of children that will be kept running. The minimum
possible value is 1, the default value is 1 in spamd, and undef here. If you have lots of
free RAM, you may want to increase this.

Default value: `undef`

##### <a name="-spamassassin--spamd_listen_address"></a>`spamd_listen_address`

Data type: `Array[Stdlib::Host]`

List of IP addresses spamd will listen to (defaults to "localhost", which
will listen both on IPv4 and IPv6 locally). Use 0.0.0.0 to listen on all
interfaces. You can also use a valid hostname which will make spamd listen
on the first address that name resolves to. To listen only to an IPv6
address, make sure to encase the address within square brackets (i.e.
"[fe80::fc54:ff:fe8f:4b36]")

Default value: `['localhost']`

##### <a name="-spamassassin--spamd_allowed_ips"></a>`spamd_allowed_ips`

Data type: `Array[String]`

Specify a list of authorized hosts or networks which can connect to this
spamd instance. Values can be single IP addresses or CIDR format networks.
Hostnames are not supported, only IP addresses. Similarly to
`spamd_listen_address`, to specify IPs or CIDR notation for IPV6, make sure
to encase the address or network part in square brackets)

Default value: `['127.0.0.1/32','[::1]/8']`

##### <a name="-spamassassin--spamd_username"></a>`spamd_username`

Data type: `Optional[String]`

spamd runs as this user

Default value: `undef`

##### <a name="-spamassassin--spamd_groupname"></a>`spamd_groupname`

Data type: `Optional[String]`

spamd runs in this group

Default value: `undef`

##### <a name="-spamassassin--spamd_nouserconfig"></a>`spamd_nouserconfig`

Data type: `Boolean`

Turn off (on) reading of per-user configuration files (user_prefs) from the
user's home directory. The default behaviour is to read per-user
configuration from the user's home directory (`--user-config`/`-c`).
Note that by default `spamd_defaults` activates `--create-prefs` so you may
want to revise that parameter if you set this option.

Default value: `false`

##### <a name="-spamassassin--spamd_allowtell"></a>`spamd_allowtell`

Data type: `Boolean`

Allow learning and forgetting (to a local Bayes database), reporting and
revoking (to a remote database) by spamd. The client issues a TELL command
to tell what type of message is being processed and whether local
(learn/forget) or remote (report/revoke) databases should be updated.

Default value: `false`

##### <a name="-spamassassin--spamd_sql_config"></a>`spamd_sql_config`

Data type: `Boolean`

Turn on SQL lookups even when per-user config files have been disabled with
`-x` this is useful for spamd hosts which dont have users home directories
but do want to load user preferences from an SQL database.

Default value: `false`

##### <a name="-spamassassin--spamd_syslog_facility"></a>`spamd_syslog_facility`

Data type: `Optional[String]`

Turn this on to deposit logs for SpamAssassin and define the log location.
e.g. `/var/log/spamd.log`

Default value: `undef`

##### <a name="-spamassassin--configdir"></a>`configdir`

Data type: `Stdlib::Absolutepath`

Absolute path to the directory containing spamassassin's configuration files.

Default value: `$spamassassin::params::configdir`

##### <a name="-spamassassin--spamd_options_file"></a>`spamd_options_file`

Data type: `Stdlib::Absolutepath`

Absolute path to the file containing global options to spamd.

Default value: `$spamassassin::params::spamd_options_file`

##### <a name="-spamassassin--spamd_options_var"></a>`spamd_options_var`

Data type: `String`

Name of the shell variable used for storing spamd options in
`spamd_options_file`.

Default value: `$spamassassin::params::spamd_options_var`

##### <a name="-spamassassin--spamd_defaults"></a>`spamd_defaults`

Data type: `String`

String of spamd option flags set in `spamd_options_file`. If you change some
parameters you may need to revise those deamon flags.

Default value: `$spamassassin::params::spamd_defaults`

##### <a name="-spamassassin--sa_update_file"></a>`sa_update_file`

Data type: `Stdlib::Absolutepath`

Absolute path to file that contains shell variables for sa-update.

Default value: `$spamassassin::params::sa_update_file`

##### <a name="-spamassassin--required_score"></a>`required_score`

Data type: `Numeric`

Set the score required before a mail is considered spam. Can be an integer
or a floating-point number.

Default value: `5`

##### <a name="-spamassassin--score_tests"></a>`score_tests`

Data type: `Hash`

Assign scores (the number of points for a hit) to a given test. Scores can
be positive or negative real numbers or integers.

Default value: `{}`

##### <a name="-spamassassin--whitelist_from"></a>`whitelist_from`

Data type: `Array`

Used to whitelist sender addresses which send mail that is often tagged
(incorrectly) as spam. This would be written to the global `local.cf` file

Default value: `[]`

##### <a name="-spamassassin--whitelist_from_rcvd"></a>`whitelist_from_rcvd`

Data type: `Array`

Used to whitelist the combination of a sender address and rDNS name/IP. This
would be written to the global `local.cf` file

Default value: `[]`

##### <a name="-spamassassin--whitelist_to"></a>`whitelist_to`

Data type: `Array`

If the given address appears as a recipient in the message headers
(Resent-To, To, Cc, obvious envelope recipient, etc.) the mail will be
whitelisted.

Default value: `[]`

##### <a name="-spamassassin--blacklist_from"></a>`blacklist_from`

Data type: `Array`

Used to specify addresses which send mail that is often tagged (incorrectly)
as non-spam, but which the user doesn't want.

Default value: `[]`

##### <a name="-spamassassin--blacklist_to"></a>`blacklist_to`

Data type: `Array`

If the given address appears as a recipient in the message headers
(Resent-To, To, Cc, obvious envelope recipient, etc.) the mail will be
blacklisted.

Default value: `[]`

##### <a name="-spamassassin--rewrite_header_subject"></a>`rewrite_header_subject`

Data type: `Optional[String]`

By default, suspected spam messages will not have the Subject, From or To
lines tagged to indicate spam. By setting this option, the header will be
tagged with the value of the parameter to indicate that a message is spam.

Default value: `undef`

##### <a name="-spamassassin--rewrite_header_from"></a>`rewrite_header_from`

Data type: `Optional[String]`

See `rewrite_header_subject`.

Default value: `undef`

##### <a name="-spamassassin--rewrite_header_to"></a>`rewrite_header_to`

Data type: `Optional[String]`

See `rewrite_header_subject`.

Default value: `undef`

##### <a name="-spamassassin--report_safe"></a>`report_safe`

Data type: `Integer[0,2]`

See: https://spamassassin.apache.org/full/4.0.x/doc/Mail_SpamAssassin_Conf.html#report_safe-0-1-2-default:-1

Default value: `0`

##### <a name="-spamassassin--add_header_spam"></a>`add_header_spam`

Data type: `Array`

Customise headers to be added to spam emails. Each array item should
contain: `header_name` string.

Default value: `[]`

##### <a name="-spamassassin--add_header_ham"></a>`add_header_ham`

Data type: `Array`

See `add_header_spam`.

Default value: `[]`

##### <a name="-spamassassin--add_header_all"></a>`add_header_all`

Data type: `Array`

See `add_header_spam`.

Default value: `[]`

##### <a name="-spamassassin--remove_header_spam"></a>`remove_header_spam`

Data type: `Array`

Remove headers from spam emails. Each array item should be a `header_name`
to remove.

Default value: `[]`

##### <a name="-spamassassin--remove_header_ham"></a>`remove_header_ham`

Data type: `Array`

See `remove_header_spam`.

Default value: `[]`

##### <a name="-spamassassin--remove_header_all"></a>`remove_header_all`

Data type: `Array`

See `remove_header_spam`.

Default value: `[]`

##### <a name="-spamassassin--clear_trusted_networks"></a>`clear_trusted_networks`

Data type: `Boolean`

Empty the list of trusted networks.

Default value: `false`

##### <a name="-spamassassin--trusted_networks"></a>`trusted_networks`

Data type: `Array`

What networks or hosts are 'trusted' in your setup. Trusted in this case
means that relay hosts on these networks are considered to not be
potentially operated by spammers, open relays, or open proxies.

Default value: `[]`

##### <a name="-spamassassin--clear_internal_networks"></a>`clear_internal_networks`

Data type: `Boolean`

Empty the list of internal networks.

Default value: `false`

##### <a name="-spamassassin--internal_networks"></a>`internal_networks`

Data type: `Array`

Internal means that relay hosts on these networks are considered to be MXes
for your domain(s), or internal relays.

Default value: `[]`

##### <a name="-spamassassin--skip_rbl_checks"></a>`skip_rbl_checks`

Data type: `Boolean`

If false SpamAssassin will run RBL checks.

Default value: `true`

##### <a name="-spamassassin--dns_available"></a>`dns_available`

Data type: `Pattern[/^(test|yes|no)$/]`

If set to 'test', SpamAssassin will query some default hosts on the internet
to attempt to check if DNS is working or not.

Default value: `'yes'`

##### <a name="-spamassassin--uridnsbl_skip_domain"></a>`uridnsbl_skip_domain`

Data type: `Array[String]`

List of domains for which URIDNSBL tests should be skipped. This can be used
to reduce the volume of URIBDNSBL checks, for example by disabling checks
for known domains that get sent to very often.

Default value: `[]`

##### <a name="-spamassassin--uridnsbl"></a>`uridnsbl`

Data type: `Hash[String, Array[String,2,2]]`

Specify a lookup. Each entry's key is the name of the rule to be used. The
value should be an array with two items. The first item is the dnsbl zone to
lookup IPs in, and the second item is the type of lookup to perform (TXT or
A). Note that you must also define a body-eval rule calling check_uridnsbl()
to use this.

Default value: `{}`

##### <a name="-spamassassin--urirhsbl"></a>`urirhsbl`

Data type: `Hash[String, Array[String,2,2]]`

Specify a RHSBL-style domain lookup. Each entry's key is the name of the
rule to be used. The value should be an array with two items. The first item
is the dnsbl zone to lookup IPs in, and the second item is the type of
lookup to perform (TXT or A).

Default value: `{}`

##### <a name="-spamassassin--urirhssub"></a>`urirhssub`

Data type: `Hash[String, Array[String,3,3]]`

Specify a RHSBL-style domain lookup with a sub-test. Each entry's key is the
name of the rule to be used. The value should be an array with three items.
The first item is the dnsbl zone to lookup IPs in. The second item is the
type of lookup to perform (TXT or A). Finally, the third item is the
sub-test to run against the returned data.

Default value: `{}`

##### <a name="-spamassassin--bayes_enabled"></a>`bayes_enabled`

Data type: `Boolean`

Whether to use the naive-Bayesian-style classifier built into SpamAssassin.

Default value: `true`

##### <a name="-spamassassin--bayes_use_hapaxes"></a>`bayes_use_hapaxes`

Data type: `Boolean`

Should the Bayesian classifier use hapaxes (words/tokens that occur only
once) when classifying? This produces significantly better hit-rates, but
increases database size by about a factor of 8 to 10.

Default value: `true`

##### <a name="-spamassassin--bayes_auto_learn"></a>`bayes_auto_learn`

Data type: `Boolean`

Whether SpamAssassin should automatically feed high-scoring mails into its
learning systems.

Default value: `true`

##### <a name="-spamassassin--bayes_ignore_header"></a>`bayes_ignore_header`

Data type: `Array`

List of email header names that spamd should ignore.
See https://spamassassin.apache.org/full/4.0.x/doc/Mail_SpamAssassin_Conf.html#bayes_ignore_header-header_name

Default value: `[]`

##### <a name="-spamassassin--bayes_auto_expire"></a>`bayes_auto_expire`

Data type: `Boolean`

If enabled, the Bayes system will try to automatically expire old tokens
from the database.

Default value: `true`

##### <a name="-spamassassin--bayes_sql_enabled"></a>`bayes_sql_enabled`

Data type: `Boolean`

If true will write the SQL-related directives to `local.cf`.

Default value: `false`

##### <a name="-spamassassin--bayes_sql_dsn"></a>`bayes_sql_dsn`

Data type: `String`

This parameter gives the connect string used to connect to the SQL based
Bayes storage. By default will use the mysql driver and a database called
spamassassin. Please note the module does not manage any database settings
or the creation of the schema.

Default value: `'DBI:mysql:spamassassin'`

##### <a name="-spamassassin--bayes_sql_username"></a>`bayes_sql_username`

Data type: `String`

The sql username used for the dsn provided above.

Default value: `'root'`

##### <a name="-spamassassin--bayes_sql_password"></a>`bayes_sql_password`

Data type: `Optional[String]`

The sql password used for the dsn provided above.

Default value: `undef`

##### <a name="-spamassassin--bayes_sql_override_username"></a>`bayes_sql_override_username`

Data type: `Optional[String]`

If this options is set the BayesStore::SQL module will override the set
username with the value given. This could be useful for implementing global
or group bayes databases.

Default value: `undef`

##### <a name="-spamassassin--bayes_store_module"></a>`bayes_store_module`

Data type: `String`

This parameter configures the module that spamassassin will use when
connecting to the Bayes SQL database. The default will work for most
database types, but selecting the module for a DBMS may result provide
performance improvements or additional features. Certain modules may require
the additional perl modules that are not installed by this Puppet module.

Default value: `'Mail::SpamAssassin::BayesStore::SQL'`

##### <a name="-spamassassin--bayes_path"></a>`bayes_path`

Data type: `Optional[Stdlib::Absolutepath]`

This is the directory and filename for Bayes databases. Please note this
parameter is not used if `bayes_sql_enabled` is true.

Default value: `undef`

##### <a name="-spamassassin--bayes_file_mode"></a>`bayes_file_mode`

Data type: `Optional[String]`

The permissions that spamassassin will set to the bayes file that it may
create.

Default value: `undef`

##### <a name="-spamassassin--bayes_auto_learn_threshold_nonspam"></a>`bayes_auto_learn_threshold_nonspam`

Data type: `Optional[Float]`

Score at which SA learns the message as ham.

Default value: `undef`

##### <a name="-spamassassin--bayes_auto_learn_threshold_spam"></a>`bayes_auto_learn_threshold_spam`

Data type: `Optional[Float]`

Score at which SA learns the message as spam.

Default value: `undef`

##### <a name="-spamassassin--user_scores_dsn"></a>`user_scores_dsn`

Data type: `Optional[String]`

The perl DBI DSN string used to specify the SQL server holding user config.
Example: 'DBI:mysql:dbname:hostname

Default value: `undef`

##### <a name="-spamassassin--user_scores_sql_username"></a>`user_scores_sql_username`

Data type: `Optional[String]`

The SQL username to connect to the above server.

Default value: `undef`

##### <a name="-spamassassin--user_scores_sql_password"></a>`user_scores_sql_password`

Data type: `Optional[String]`

The SQL password for the above user.

Default value: `undef`

##### <a name="-spamassassin--user_scores_sql_custom_query"></a>`user_scores_sql_custom_query`

Data type: `Optional[String]`

Custom SQL query to use for spamd user_prefs.

Default value: `undef`

##### <a name="-spamassassin--dcc_enabled"></a>`dcc_enabled`

Data type: `Boolean`

Enable/disable the DCC plugin.

Default value: `false`

##### <a name="-spamassassin--dcc_timeout"></a>`dcc_timeout`

Data type: `Optional[Integer]`

How many seconds you wait for DCC to complete, before scanning continues
without the DCC results. If left undef, spamd uses its default value of 5

Default value: `undef`

##### <a name="-spamassassin--dcc_body_max"></a>`dcc_body_max`

Data type: `Optional[Integer]`

This option sets how often a message's body/fuz1/fuz2 checksum must have
been reported to the DCC server before SpamAssassin will consider the DCC
check as matched. As nearly all DCC clients are auto-reporting these
checksums, you should set this to a relatively high value, e.g. 999999 (this
is DCC's MANY count). If left undef, spamd uses its default value of 999999

Default value: `undef`

##### <a name="-spamassassin--dcc_fuz1_max"></a>`dcc_fuz1_max`

Data type: `Optional[Integer]`

See `dcc_body_max`. If left undef, spamd uses its default value of 999999

Default value: `undef`

##### <a name="-spamassassin--dcc_fuz2_max"></a>`dcc_fuz2_max`

Data type: `Optional[Integer]`

See `dcc_body_max`. If left undef, spamd uses its default value of 999999

Default value: `undef`

##### <a name="-spamassassin--pyzor_enabled"></a>`pyzor_enabled`

Data type: `Boolean`

Enable/disable the Pyzor plugin.

Default value: `true`

##### <a name="-spamassassin--pyzor_timeout"></a>`pyzor_timeout`

Data type: `Optional[Numeric]`

How many seconds you wait for Pyzor to complete, before scanning continues
without the Pyzor results. If left undef, spamd uses its default of 5

Default value: `undef`

##### <a name="-spamassassin--pyzor_max"></a>`pyzor_max`

Data type: `Optional[Integer]`

See `pyzor_count_min`. Note that this option has been renamed to
`pyzor_count_min` in spamassassin 4.0.x and it cannot be used from that
version onwards.

Default value: `undef`

##### <a name="-spamassassin--pyzor_count_min"></a>`pyzor_count_min`

Data type: `Optional[Integer]`

This option sets how often a message's body checksum must have been reported
to the Pyzor server before SpamAssassin will consider the Pyzor check as
matched. If left undefined, spamd will use its default of 5. Note that this
option does not exist in versions prior to 4.0.x.

Default value: `undef`

##### <a name="-spamassassin--pyzor_options"></a>`pyzor_options`

Data type: `Optional[Pattern[/[0-9A-Za-z ,._\/-]\+/]]`

Specify additional options to the pyzor command. Please note that only
characters in the range `[0-9A-Za-z ,._/-]` are allowed for security reasons.
Please note that the module will automatically add the homedir options as
part of the configuration.

Default value: `undef`

##### <a name="-spamassassin--pyzor_path"></a>`pyzor_path`

Data type: `Optional[Stdlib::Absolutepath]`

This option tells SpamAssassin specifically where to find the pyzor client
instead of relying on SpamAssassin to find it in the current PATH.

Default value: `undef`

##### <a name="-spamassassin--pyzor_home"></a>`pyzor_home`

Data type: `Stdlib::Absolutepath`

Define the homedir for pyzor. Default is to use the [global config dir]/.pyzor

Default value: `$spamassassin::params::pyzor_home`

##### <a name="-spamassassin--razor_enabled"></a>`razor_enabled`

Data type: `Boolean`

Enable/disable the Razor2 plugin.

Default value: `true`

##### <a name="-spamassassin--razor_timeout"></a>`razor_timeout`

Data type: `Optional[Integer]`

How many seconds you wait for Razor to complete before you go on without the
results. If left undefined, spamd will use its default of 5

Default value: `undef`

##### <a name="-spamassassin--razor_home"></a>`razor_home`

Data type: `Stdlib::Absolutepath`

Define the homedir for razor. Please note that if you set a custom path the
module will automatically use the directory in which you store your razor
config as the home directory for the module. Default is to use the [global
config dir]/.razor

Default value: `$spamassassin::params::razor_home`

##### <a name="-spamassassin--spamcop_enabled"></a>`spamcop_enabled`

Data type: `Boolean`

Enable/disable the Pyzor plugin.

Default value: `false`

##### <a name="-spamassassin--spamcop_from_address"></a>`spamcop_from_address`

Data type: `Optional[String]`

This address is used during manual reports to SpamCop as the From: address.
You can use your normal email address. If this is not set, a guess will be
used as the From: address in SpamCop reports.

Default value: `undef`

##### <a name="-spamassassin--spamcop_to_address"></a>`spamcop_to_address`

Data type: `Optional[String]`

Your customized SpamCop report submission address. You need to obtain this
address by registering at http://www.spamcop.net/. If this is not set,
SpamCop reports will go to a generic reporting address for SpamAssassin
users and your reports will probably have less weight in the SpamCop system.

Default value: `undef`

##### <a name="-spamassassin--spamcop_max_report_size"></a>`spamcop_max_report_size`

Data type: `Optional[Integer]`

Messages larger than this size (in kilobytes) will be truncated in report
messages sent to SpamCop. The default setting is the maximum size that
SpamCop will accept at the time of release. If left undefined, spamd uses
its default of 50

Default value: `undef`

##### <a name="-spamassassin--awl_enabled"></a>`awl_enabled`

Data type: `Boolean`

Enable/disable the Auto-Whitelist plugin.

Default value: `false`

##### <a name="-spamassassin--awl_sql_enabled"></a>`awl_sql_enabled`

Data type: `Boolean`

If true will set auto_whitelist_factory to use sql and will write the sql
dsn, and other directives, to local.cf.

Default value: `false`

##### <a name="-spamassassin--awl_dsn"></a>`awl_dsn`

Data type: `String`

This parameter gives the connect string used to connect to the SQL based
storage. By default will use the mysql driver and a database called
spamassassin. Please note the module does not manage any database settings
or the creation of the schema.

Default value: `'DBI:mysql:spamassassin'`

##### <a name="-spamassassin--awl_sql_username"></a>`awl_sql_username`

Data type: `String`

The sql username used for the dsn provided above.

Default value: `'root'`

##### <a name="-spamassassin--awl_sql_password"></a>`awl_sql_password`

Data type: `Optional[String]`

The sql password used for the dsn provided above.

Default value: `undef`

##### <a name="-spamassassin--awl_sql_override_username"></a>`awl_sql_override_username`

Data type: `Optional[String]`

Used by the SQLBasedAddrList storage implementation. If this option is set
the SQLBasedAddrList module will override the set username with the value
given. This can be useful for implementing global or group based
auto-whitelist databases.

Default value: `undef`

##### <a name="-spamassassin--auto_whitelist_path"></a>`auto_whitelist_path`

Data type: `Optional[String]`

See `auto_welcomelist_path`. Note that the option was renamed to
`auto_welcomelist_path` in spamassassin 4.0.x. `auto_whitelist_path` is
still valid with 4.0.x, but is planned to be removed in 4.1.x.

Default value: `undef`

##### <a name="-spamassassin--auto_welcomelist_path"></a>`auto_welcomelist_path`

Data type: `Optional[String]`

This is the automatic-welcomelist directory and filename. By default, each
user has their own welcomelist database in their ~/.spamassassin directory
with mode 0700. For system-wide SpamAssassin use, you may want to share this
across all users, although that is not recommended. If left undefined, spamd
will use its default value of `~/.spamassassin/auto-whitelist`.

Default value: `undef`

##### <a name="-spamassassin--auto_whitelist_file_mode"></a>`auto_whitelist_file_mode`

Data type: `Optional[String]`

See `auto_welcomelist_file_mode`. Note that this option was renamed to
`auto_welcomelist_file_mode` in spamassassin 4.0.x.
`auto_whitelist_file_mode` is still valid with 4.0.x, but is planned to be
removed in 4.1.x.

Default value: `undef`

##### <a name="-spamassassin--auto_welcomelist_file_mode"></a>`auto_welcomelist_file_mode`

Data type: `Optional[String]`

The file mode bits used for the automatic-whitelist directory or file. Make
sure you specify this using the 'x' mode bits set, as it may also be used to
create directories. However, if a file is created, the resulting file will
not have any execute bits set (the umask is set to 0111). If left undefined,
spamd will use its default of `0700`.

Default value: `undef`

##### <a name="-spamassassin--textcat_enabled"></a>`textcat_enabled`

Data type: `Boolean`

Enable/disable the TextCat plugin.

Default value: `false`

##### <a name="-spamassassin--ok_languages"></a>`ok_languages`

Data type: `Array[String]`

List of languages which are considered okay for incoming mail. If unset,
defaults to accepting all languages.

Default value: `['all']`

##### <a name="-spamassassin--ok_locales"></a>`ok_locales`

Data type: `Array[String]`

List of charsets that are permitted. If unset, defaults to accepting all
locales.

Default value: `['all']`

##### <a name="-spamassassin--normalize_charset"></a>`normalize_charset`

Data type: `Boolean`

Enable/disable scanning non-UTF8 or non-ASCII parts to guess charset.

Default value: `false`

##### <a name="-spamassassin--shortcircuit_enabled"></a>`shortcircuit_enabled`

Data type: `Boolean`

Enable/disable the Shortcircuit plugin.

Default value: `false`

##### <a name="-spamassassin--shortcircuit_user_in_whitelist"></a>`shortcircuit_user_in_whitelist`

Data type: `Optional[Enum['ham','spam','on','off']]`

Values: ham, spam, on or off.

Default value: `undef`

##### <a name="-spamassassin--shortcircuit_user_in_def_whitelist"></a>`shortcircuit_user_in_def_whitelist`

Data type: `Optional[Enum['ham','spam','on','off']]`

Values: ham, spam, on or off.

Default value: `undef`

##### <a name="-spamassassin--shortcircuit_user_in_all_spam_to"></a>`shortcircuit_user_in_all_spam_to`

Data type: `Optional[Enum['ham','spam','on','off']]`

Values: ham, spam, on or off.

Default value: `undef`

##### <a name="-spamassassin--shortcircuit_subject_in_whitelist"></a>`shortcircuit_subject_in_whitelist`

Data type: `Optional[Enum['ham','spam','on','off']]`

Values: ham, spam, on or off.

Default value: `undef`

##### <a name="-spamassassin--shortcircuit_user_in_blacklist"></a>`shortcircuit_user_in_blacklist`

Data type: `Optional[Enum['ham','spam','on','off']]`

Values: ham, spam, on or off.

Default value: `undef`

##### <a name="-spamassassin--shortcircuit_user_in_blacklist_to"></a>`shortcircuit_user_in_blacklist_to`

Data type: `Optional[Enum['ham','spam','on','off']]`

Values: ham, spam, on or off.

Default value: `undef`

##### <a name="-spamassassin--shortcircuit_subject_in_blacklist"></a>`shortcircuit_subject_in_blacklist`

Data type: `Optional[Enum['ham','spam','on','off']]`

Values: ham, spam, on or off.

Default value: `undef`

##### <a name="-spamassassin--shortcircuit_all_trusted"></a>`shortcircuit_all_trusted`

Data type: `Optional[Enum['ham','spam','on','off']]`

Values: ham, spam, on or off.

Default value: `undef`

##### <a name="-spamassassin--dkim_enabled"></a>`dkim_enabled`

Data type: `Boolean`

Enable/disable the DKIM plugin.

Default value: `true`

##### <a name="-spamassassin--dkim_timeout"></a>`dkim_timeout`

Data type: `Optional[Integer]`

How many seconds to wait for a DKIM query to complete, before scanning
continues without the DKIM result. If left undefined, spamd will use its
default value of 3.5

Default value: `undef`

##### <a name="-spamassassin--rules2xsbody_enabled"></a>`rules2xsbody_enabled`

Data type: `Boolean`

Enable the Rule2XSBody plugin. Compile ruleset to native code with
sa-compile. Requires re2c and gcc packages (not managed in this module)

Default value: `false`

##### <a name="-spamassassin--custom_rules"></a>`custom_rules`

Data type: `Hash`

Define custom rules. This is a hash of hashes. The key for the outer hash is
the spamassassin rule name, the inner hash for each entry should contain the
rule definition, e.g:

  spamassassin::custom_rules:
    INVOICE_SPAM:
      body: '/Invoice.*from.*You have received an invoice from .* To start with it, print out or download a JS copy of your invoice/'
      score: 6
      describe: 'spam reported claiming "You have received an invoice"'

Default value: `{}`

##### <a name="-spamassassin--custom_config"></a>`custom_config`

Data type: `Array[String]`

Add custom lines to the config file. Useful for configuring modules that
aren't otherwise handled by this Puppet module. This is an array of strings,
e.g:

  spamassassin::custom_config:
    - hashcash_accept *@example.com
    - hashcash_accept *@example.net

Default value: `[]`

